/* TEPS: Haupteil/Reaktion auf Benutzer */

#include <osbind.h>
#include <falcon.h>
#include <aes.h>
#include <string.h>
#include "teps.h"
#include "windial.h"

#ifndef TRUE
#define TRUE   -1
#endif

/* Prototypen: */
void write_error(char *text);                /* ->TEPSINIT */
int  initsamplebuf(void);
int  initGEM(void);
void exitGEM(void);
void drawsample(void);                       /* ->TEPSGRAF */
void oscilloscope(void);
void do_slider(int pa_box, int slider, int sndcmd);
int  do_popup(OBJECT *buttree, int butnr, MENU *popdat);
void swtchsign(char *start, char *ende, int modus);   /* ->TEPSCONV */

short msgbuff[8];                  /* Nachrichtenbuffer */
OBJECT *menutree;                /* Adresse des Menbalkens */
OBJECT *dialtree;                /*  "      " Dialogfeldes */
MENU modipopup = { 0L, MODIBOX, M8BUT, 0, 0 };   /* Fr Modi-PopUpmen */
MENU freqspopup = { 0L, FREQSBOX, F12KHZ, 0, 0 };
int swihndl;                     /* Sample-Fensterkennung */
short dwix, dwiy, dwiw, dwih;

char *sambufstart;               /* Zeiger auf den Sample-Buffer */
char *sambufend;                 /* Zeiger aufs Ende */
char *playbufstart;
char *playbufend;
long samlength;
long playlength;
int sndmodus=0;                  /* 0=Mono8, 1=Stereo8, 2=Stereo16 */

int fdtyp;						/* Fr new-form-do */
E_FO_DO efdstrct;
char endeflag=0;				/* Wenn true -> Ende */

char *dateiname="NO_NAME_.SAM";   /* Globaler Filename */
char fpath[128]="A:\*.*";         /* Globaler Pfadname */

/* ***Fileselectbox darstellen und Name zusammenfgen*** */
int fileselect(char *pathnname, char *boxtitle)
{
 int i, fs_button;
 char *pathend;

 wind_update(BEG_MCTRL);
 if(gl_apversion>0x0130)
   i=fsel_exinput(fpath, dateiname, &fs_button, boxtitle);
  else
   i=fsel_input(fpath, dateiname, &fs_button);
 wind_update(END_MCTRL);
 if(i==0 || fs_button==0)  return(-1);

 strcpy(pathnname, fpath);
 pathend=strrchr(pathnname, '\\');
 if(pathend==0)
   pathend=pathnname; else ++pathend;
 strcpy(pathend, dateiname);            /* Pfad und Name zusammen */

 return(0);
}

/* ***Ein Sample laden*** */
void loadsample(void)
{
 char fullname[128];
 int fhandle;

 if( fileselect(fullname, "Sample laden") ) /* Pfad und Name -> fullname */
   return;

 fhandle=Fopen(fullname, 0);
 playlength=Fread(fhandle, samlength, sambufstart);
 if(playlength<0L)
  {
   write_error("Datei konnte|nicht geladen werden!");
   playlength=samlength;
  }
 playbufend=playbufstart+playlength;
 Setbuffer(0, playbufstart, playbufend);
 Fclose(fhandle);
}

/* ***Ankreuzbares Objekt behandeln*** */
void cross_objc(OBJECT *cobj, int ci)
{
 int dum, mbut;
 cobj[ci].ob_state ^= CROSSED;
 objc_draw(cobj, ci, 0, cobj->ob_x, cobj->ob_y,
           cobj->ob_height, cobj->ob_width);
 do
  {
   graf_mkstate(&dum, &dum, &mbut, &dum);
  }
 while(mbut==1);        /* Bis Maustaste losgelassen wird */
}

/* ***Menauswahl*** */
void reactmenu(void)
{
 register long *s_pos;
 int cwhndl;

 switch(msgbuff[4])
  {
   case ABOUT:
    form_alert(1,
      "[1][TEPS V0.8|Player fr Samplesounds"
      "|Geschrieben von T. Huth|\xBD 1996][ OK ]");
    break;
   case NEW:
    for(s_pos=(long *)playbufstart; s_pos<(long *)playbufend; s_pos++)
      *s_pos=0;
    drawsample();
    break;
   case SAMLOAD:
    loadsample();
    break;
   case ENDE:
    endeflag=TRUE;      /* Ende signalisieren */
    break;
   case CHGNSIGN:
    swtchsign(playbufstart, playbufend, sndmodus);
    drawsample();
    break;
  }

 menu_tnormal(menutree, msgbuff[3], 1);
}

/* ***Hauptteil*** */
int main(void)
{
 int i;

 if( initGEM() )  { return(-1); }

 i=(int)Locksnd();             /* Soundsubsystem fr andere sperren */
 if(i!=1)
  {
   if(i==-129)
    {
     if(form_alert(1, "[3][Soundsubsystem ist|schon gesperrt!][Weiter|Stop]")==2)
      {exitGEM();  return(-1);}
    }
    else
    {
     if(form_alert(1, "[3][Kein Soundsubsystem|vorhanden!][Weiter|Stop]")==2)
      {exitGEM();  return(-1);}
    }
  }

 if( initsamplebuf() )  { exitGEM(); Unlocksnd(); return(-1); }

 fpath[0]+=Dgetdrv();      /* Laufwerk ermitteln */

 efdstrct.tree=dialtree;
 efdstrct.msgbuf=msgbuff;
 efdstrct.strt_fld=0;
 if(wdial_init(&efdstrct, "TEPS - The Sampleplayer"))
  { exitGEM(); Unlocksnd(); return(-1); }

 do
 {
  fdtyp=e_form_do(&efdstrct);					/* Form-Do + Evnt-Multi */
  wind_get(efdstrct.dwhndl, WF_WORKXYWH, &dwix, &dwiy, &dwiw, &dwih);

  if(fdtyp==1)    /* Dialog-Ereigniss auswerten */
   {
    switch(efdstrct.choice)
     {
      case PLAY:
        if(dialtree[SREPEAT].ob_state & CROSSED)  i=3;  else i=1;
        if( Buffoper(i) )
          write_error("Sample konnte nicht|gestartet werden!");
//        efdstrct.etimer=40;  /* 40 Millisekunden = 25Hz */
        objc_change(dialtree, PLAY, 0, dwix, dwiy, dwiw, dwih, NORMAL, 1);
        break;
      case STOP:
        if( Buffoper(0) )
          write_error("Sample konnte nicht|angehalten werden!");
        objc_change(dialtree, STOP, 0, dwix, dwiy, dwiw, dwih, NORMAL, 1);
        efdstrct.etimer=0;
        drawsample();
        break;
      case MODUSBUT:
        if( do_popup(dialtree, MODUSBUT, &modipopup) )
        switch(modipopup.mn_item)
         {
          case M8BUT:  Setmode(MONO8); sndmodus=0; break;
          case S8BUT:  Setmode(STEREO8); sndmodus=1; break;
          case S16BUT:
           if(Setmode(STEREO16))
             write_error("Kein 16-Bit mglich!");
            else sndmodus=2;
           break;
         }
        break;
      case FREQBUT:
        if( do_popup(dialtree, FREQBUT, &freqspopup) )
          Devconnect(DMAPLAY, DAC, 0, freqspopup.mn_item-F50KHZ+1, 1);
        break;
      case SREPEAT:
        cross_objc(dialtree, SREPEAT);
        if(Buffoper(-1)!=0)
         if(dialtree[SREPEAT].ob_state & CROSSED)
          Buffoper(3);  else Buffoper(1);
        break;
      case LVOLSLID:
        do_slider(LVOLBOX, LVOLSLID, 0);
        break;
      case RVOLSLID:
        do_slider(RVOLBOX, RVOLSLID, 1);
        break;
     }
   }

  if(fdtyp==2)    /* Mesage-Buffer auswerten */
   {
   switch(msgbuff[0])
    {
     case WM_REDRAW:
      if(msgbuff[3]==swihndl)  drawsample();
      break;
     case WM_TOPPED:
      wind_set(msgbuff[3], WF_TOP, msgbuff[3], 0, 0L);
      break;
     case WM_MOVED:
      wind_set(msgbuff[3], WF_CURRXYWH, msgbuff[4], msgbuff[5],
            msgbuff[6], msgbuff[7]);
      break;
     case MN_SELECTED:
      reactmenu();
      break;
    }
   }

//  if(fdtyp==3)   /* Bestimmte Zeit verstrichen -> Oszilloskop */
//   {
//   oscilloscope();
//   if((Buffoper(-1) & 1L)==0)  { efdstrct.etimer=0; drawsample(); }
//   }

 }
 while( !endeflag );       /* Ende der Hauptschleife */

 wdial_close(efdstrct.dwhndl);
 exitGEM();
 Unlocksnd();
 return(0);
}
