/* ### Headerdatei fr Fensterdialoge ### */

#include <aes.h>

typedef struct
{
 short choice;
 OBJECT *tree;
 short strt_fld;
 short dwhndl;
 short *msgbuf;
 long etimer;
 short kshift, kcode;
} E_FO_DO;

#define EFD_FORMDO 1
#define EFD_MESAG  2
#define EFD_TIMER  3
#define EFD_KEY    4

/* ***Fenster anmelden + Dialog zeichnen*** */
short wdial_init(E_FO_DO *efd, char *title)
{
 short wx, wy, ww, wh;

 form_center(efd->tree, &wx, &wy, &ww, &wh);           /* Gre holen */
 wind_calc(WC_BORDER, NAME|MOVER, wx, wy, ww, wh, &wx, &wy, &ww, &wh);
 efd->dwhndl=wind_create(NAME|MOVER, wx, wy, ww, wh);  /* Fenster anmelden */
 if(efd->dwhndl<0)  return(-1);
 wind_set(efd->dwhndl, WF_NAME, title);                /* Name setzen */
 wind_open(efd->dwhndl, wx, wy, ww, wh);               /* Fenster ffnen */
 objc_draw(efd->tree, ROOT, MAX_DEPTH, wx, wy, ww, wh);  /* Dialog zeichnen */

 return(0);
}

/* ***Fenster schlieen + lschen*** */
void wdial_close(short whandle)
{
 wind_close(whandle);                           /* Fenster schliessen */
 wind_delete(whandle);                          /* Fenster abmelden */
}

/* ***Dialog neu zeichnen, Rechteckliste beachten*** */
void wdial_redraw(E_FO_DO *efd, GRECT *redrwrect)
{
 GRECT clip;               /* Fr Rechtecksliste */

 wind_update(BEG_UPDATE); graf_mouse(M_OFF, 0L);

 wind_xget(efd->dwhndl, WF_FIRSTXYWH, &clip);
 while(clip.g_w!=0 && clip.g_h!=0)
  {
   if( rc_intersect(redrwrect, &clip) )
     objc_draw(efd->tree, ROOT, MAX_DEPTH, clip.g_x, clip.g_y, clip.g_w, clip.g_h);
   wind_xget(efd->dwhndl, WF_NEXTXYWH, &clip);
  }

 graf_mouse(M_ON, 0L); wind_update(END_UPDATE);
}


/*--------------------------------------------*/
/*             A new form_do()                */
/*         for a dialog in a window           */
/*--------------------------------------------*/

#ifndef FALSE
#define  FALSE    0
#define  TRUE     -1
#endif

#ifndef FMD_DEFLT
#define  FMD_DEFLT     0
#define  FMD_FORWARD   1
#define  FMD_BACKWARD  2
#endif

#ifndef NO_OBJECT
#define NO_OBJECT  -1
#endif

/* **Find the first editable object in the tree** */
int find_obj(OBJECT *tree, int start_obj, int which)
{
 register int  obj, flag, theflag, inc;

 obj=0;
 flag=EDITABLE;
 inc=1;
 switch(which)
  {
   case FMD_BACKWARD:
     inc=-1;
   case FMD_FORWARD:
     obj=start_obj+inc;
     break;
   case FMD_DEFLT:
     flag=DEFAULT;
     break;
  }

 while(obj>=0)
  {
   theflag=tree[obj].ob_flags;
   if(theflag & flag)
     return(obj);
   if(theflag & LASTOB)
     obj=-1;
    else
     obj+=inc;
  }
 return(start_obj);
}

/* **Find the first edit-object** */
int fm_inifld(OBJECT *tree, int start_fld)
{
 if(start_fld==0)
   start_fld=find_obj(tree, 0, FMD_FORWARD);
 return(start_fld);
}

/* ***form-do main function*** */
short e_form_do(E_FO_DO *efd)
{
 register int  edit_obj;
 int next_obj;
 register int  which; int events=MU_KEYBD|MU_BUTTON|MU_MESAG;
 int  cont;
 int  idx;
 int  mx, my, mb, br;
 int  obx, oby, obw, obh;           /* Koordinaten des Dialogs */

 if(efd->etimer)  events|=MU_TIMER;

 next_obj=fm_inifld(efd->tree, efd->strt_fld);
 edit_obj=0;
 cont=TRUE;

 while(cont)
  {

   if( next_obj && (edit_obj!=next_obj) )
    {
     edit_obj=next_obj;
     next_obj=0;
//     objc_edit(efd->tree, edit_obj, 0, &idx, ED_INIT);
    }

   which=evnt_multi(events,
                    0x02, 0x01, 0x01,  0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
                    efd->msgbuf, (short)(efd->etimer), (short)(efd->etimer>>16),
                    &mx, &my, &mb, &efd->kshift, &efd->kcode, &br);

   if(which & MU_KEYBD)
    {
     if( efd->kshift & (K_CTRL | K_ALT) ) 
      { /*objc_edit(efd->tree, edit_obj, 0, &idx, ED_END);*/ return(EFD_KEY); }
     cont=form_keybd(efd->tree, edit_obj, next_obj, efd->kcode, &next_obj, &efd->kcode);
//     if(efd->kcode)
//       objc_edit(efd->tree, edit_obj, efd->kcode, &idx, ED_CHAR);
    }

   if(which & MU_BUTTON)
    {
     next_obj=objc_find(efd->tree, ROOT, MAX_DEPTH, mx, my);
     if(next_obj == NO_OBJECT)					/* outside of object? */
       next_obj=0;
      else
       cont=form_button(efd->tree, next_obj, br, &next_obj);
    }

   if(which & MU_MESAG)
    {
     if(efd->msgbuf[3]==efd->dwhndl)/* && efd->msgbuf[0]>=WM_REDRAW && efd->msgbuf[0]<=WM_NEWTOP)*/
      {
       switch(efd->msgbuf[0])
        {
         case WM_REDRAW:
           wdial_redraw(efd, (GRECT *)(&efd->msgbuf[4]));
           break;
         case WM_TOPPED:
           wind_set(efd->dwhndl, WF_TOP, efd->dwhndl);
           break;
         case WM_MOVED:
           wind_set(efd->dwhndl, WF_CURRXYWH, efd->msgbuf[4], efd->msgbuf[5],
                 efd->msgbuf[6], efd->msgbuf[7]);
           wind_calc(WC_WORK, NAME|MOVER, efd->msgbuf[4], efd->msgbuf[5],
                 efd->msgbuf[6], efd->msgbuf[7], &obx, &oby, &obw, &obh);
           efd->tree[ROOT].ob_x=obx;
           efd->tree[ROOT].ob_y=oby;
           break;
        }
      }
     else
      { /*objc_edit(efd->tree, edit_obj, 0, &idx, ED_END);*/ return(EFD_MESAG); }
    }

   if( (which & MU_TIMER) && cont)
    { /*objc_edit(efd->tree, edit_obj, 0, &idx, ED_END);*/ return(EFD_TIMER); }

//   if( (!cont) || (next_obj && (next_obj!=edit_obj)) )
//     objc_edit(efd->tree, edit_obj, 0, &idx, ED_END);
  }

 efd->choice=next_obj;
 return(EFD_FORMDO);
}
